using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Diagnostics;

using Microsoft.WindowsMobile.Status;
using Microsoft.WindowsMobile.PocketOutlook;
using Microsoft.WindowsMobile.PocketOutlook.MessageInterception;

namespace ThoughtWorks.PhoneGuard
{
    public partial class MainForm : Form
    {
        private ArrayList stateList = new ArrayList();
        private MessageInterceptor messageInterceptor;

        public MainForm()
        {
            InitializeComponent();            
        }

        private void mnuNew_Click(object sender, EventArgs e)
        {
            BlockNumber blockNumber = new BlockNumber();
            blockNumber.Show();
        }

        private void mnuMenuFastEntry_Click(object sender, EventArgs e)
        {
            FastEntry fastEntry = new FastEntry();
            fastEntry.Show();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            // Set up application
            SetupApplication();

            //Process p = new Process();
            //p.StartInfo.UseShellExecute = true;
            //p.StartInfo.FileName = "cprog.exe";
            //p.Start();
           
           
            //p =Process.Start("MSCProg?tapres.dll,-22555");
            //p.Start();

        }

        /// <summary>
        /// Set up the application
        /// </summary>
        private void SetupApplication()
        {
            messageInterceptor = new MessageInterceptor();
            messageInterceptor.InterceptionAction = InterceptionAction.NotifyAndDelete;
            //messageInterceptor.MessageCondition.CaseSensitive = true;
            //messageInterceptor.MessageCondition.Property = MessageProperty.Sender;
            messageInterceptor.MessageReceived += new MessageInterceptorEventHandler(Message_Received);

            SystemState s;
            s = new SystemState(SystemProperty.PhoneIncomingCall);
            s.Changed += new ChangeEventHandler(PhoneEvents_Triggered);
            stateList.Add(s);

            s = new SystemState(SystemProperty.PhoneIncomingCallerName);
            s.Changed += new ChangeEventHandler(PhoneEvents_Triggered);
            stateList.Add(s);

            s = new SystemState(SystemProperty.PhoneIncomingCallerNumber);
            s.Changed += new ChangeEventHandler(PhoneEvents_Triggered);
            stateList.Add(s);

            s = new SystemState(SystemProperty.PhoneLastIncomingCallerContact);
            s.Changed += new ChangeEventHandler(PhoneEvents_Triggered);
            stateList.Add(s);

            s = new SystemState(SystemProperty.PhoneIncomingCallerContactPropertyName);
            s.Changed += new ChangeEventHandler(PhoneEvents_Triggered);
            stateList.Add(s);
        }


        /// <summary>
        /// Invoke action based on event type
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        public void PhoneEvents_Triggered(object sender, ChangeEventArgs args)
        {
            SystemState state = (SystemState)sender;
            //if (state.CurrentValue  == SystemProperty.PhoneIncomingCall )
            //{
                txtMsg.Text += state.Property.ToString() + " = " + ConvertToString(args.NewValue) + "\r\n";
            //}
        }

        private string ConvertToString(object o)
        {
            return (o == null) ? "<null>" : o.ToString();
        }

        void Message_Received(object sender, MessageInterceptorEventArgs e)
        {
           if (e.Message is SmsMessage) 
           { 
               SmsMessage sms = (SmsMessage)e.Message;
               txtMsg.Text += sms.Body + "\r\n";
           } 

            txtMsg.Text += e.Message.From.Address.ToString() + "\n" + e.Message.From.Name.ToString() + "r\n";
        }

        private void txtMsg_TextChanged(object sender, EventArgs e)
        {

        }
        
    }
}